<?php
	// check this file's MD5 to make sure it wasn't called before
	$prevMD5=@implode('', @file(dirname(__FILE__).'/setup.md5'));
	$thisMD5=md5(@implode('', @file("./updateDB.php")));
	if($thisMD5==$prevMD5){
		$setupAlreadyRun=true;
	}else{
		// set up tables
		if(!isset($silent)){
			$silent=true;
		}

		// set up tables
		setupTable('clients', "create table if not exists `clients` (   `idclient` INT unsigned not null auto_increment , primary key (`idclient`), `matricule` VARCHAR(255) , unique `matricule_unique` (`matricule`), `responsable_administratif` VARCHAR(255) , `adresse` VARCHAR(255) , `ville` INT unsigned , `pays` VARCHAR(255) , `telephone` VARCHAR(255) , `email` VARCHAR(80) , `forme_juridique` VARCHAR(255) , `autre` VARCHAR(255) , `tdepot` DECIMAL(10,2) , `tretrait` DECIMAL(10,2) , `sold` DECIMAL(10,2) , `observations` TEXT ) CHARSET utf8", $silent);
		setupIndexes('clients', array('ville'));
		setupTable('villes', "create table if not exists `villes` (   `id` INT unsigned not null auto_increment , primary key (`id`), `ville` VARCHAR(255) ) CHARSET utf8", $silent);
		setupTable('enregistrements', "create table if not exists `enregistrements` (   `id` INT unsigned not null auto_increment , primary key (`id`), `client` INT unsigned , `domaine` VARCHAR(255) , `date_enregistrement` DATE , `date_expiration` DATE , `expiration` VARCHAR(255) ) CHARSET utf8", $silent);
		setupIndexes('enregistrements', array('client'));
		setupTable('depots', "create table if not exists `depots` (   `id` INT unsigned not null auto_increment , primary key (`id`), `matricule` INT unsigned , `client` INT unsigned , `date` DATE , `montant` DECIMAL(10,2) , `totaldepot` DECIMAL(10,2) ) CHARSET utf8", $silent);
		setupIndexes('depots', array('matricule'));
		setupTable('retraits', "create table if not exists `retraits` (   `id` INT unsigned not null auto_increment , primary key (`id`), `matricule` INT unsigned , `client` INT unsigned , `date` DATE , `domaine` VARCHAR(255) , `service` VARCHAR(255) , `montant` DECIMAL(10,2) , `totalretrait` DECIMAL(10,2) , `observations` TEXT ) CHARSET utf8", $silent);
		setupIndexes('retraits', array('matricule'));
		setupTable('soldes', "create table if not exists `soldes` (   `idsoldes` INT unsigned not null auto_increment , primary key (`idsoldes`), `matricule` INT unsigned , `client` INT unsigned , `date` DATE , `total_depot` DECIMAL(10,2) , `total_retrait` DECIMAL(10,2) , `solde` DECIMAL(10,2) ) CHARSET utf8", $silent);
		setupIndexes('soldes', array('matricule'));


		// save MD5
		if($fp=@fopen(dirname(__FILE__).'/setup.md5', 'w')){
			fwrite($fp, $thisMD5);
			fclose($fp);
		}
	}


	function setupIndexes($tableName, $arrFields){
		if(!is_array($arrFields)){
			return false;
		}

		foreach($arrFields as $fieldName){
			if(!$res=@db_query("SHOW COLUMNS FROM `$tableName` like '$fieldName'")){
				continue;
			}
			if(!$row=@db_fetch_assoc($res)){
				continue;
			}
			if($row['Key']==''){
				@db_query("ALTER TABLE `$tableName` ADD INDEX `$fieldName` (`$fieldName`)");
			}
		}
	}


	function setupTable($tableName, $createSQL='', $silent=true, $arrAlter=''){
		global $Translation;
		ob_start();

		echo '<div style="padding: 5px; border-bottom:solid 1px silver; font-family: verdana, arial; font-size: 10px;">';

		// is there a table rename query?
		if(is_array($arrAlter)){
			$matches=array();
			if(preg_match("/ALTER TABLE `(.*)` RENAME `$tableName`/", $arrAlter[0], $matches)){
				$oldTableName=$matches[1];
			}
		}

		if($res=@db_query("select count(1) from `$tableName`")){ // table already exists
			if($row = @db_fetch_array($res)){
				echo str_replace("<TableName>", $tableName, str_replace("<NumRecords>", $row[0],$Translation["table exists"]));
				if(is_array($arrAlter)){
					echo '<br>';
					foreach($arrAlter as $alter){
						if($alter!=''){
							echo "$alter ... ";
							if(!@db_query($alter)){
								echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
								echo '<div class="text-danger">' . $Translation['mysql said'] . ' ' . db_error(db_link()) . '</div>';
							}else{
								echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
							}
						}
					}
				}else{
					echo $Translation["table uptodate"];
				}
			}else{
				echo str_replace("<TableName>", $tableName, $Translation["couldnt count"]);
			}
		}else{ // given tableName doesn't exist

			if($oldTableName!=''){ // if we have a table rename query
				if($ro=@db_query("select count(1) from `$oldTableName`")){ // if old table exists, rename it.
					$renameQuery=array_shift($arrAlter); // get and remove rename query

					echo "$renameQuery ... ";
					if(!@db_query($renameQuery)){
						echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
						echo '<div class="text-danger">' . $Translation['mysql said'] . ' ' . db_error(db_link()) . '</div>';
					}else{
						echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
					}

					if(is_array($arrAlter)) setupTable($tableName, $createSQL, false, $arrAlter); // execute Alter queries on renamed table ...
				}else{ // if old tableName doesn't exist (nor the new one since we're here), then just create the table.
					setupTable($tableName, $createSQL, false); // no Alter queries passed ...
				}
			}else{ // tableName doesn't exist and no rename, so just create the table
				echo str_replace("<TableName>", $tableName, $Translation["creating table"]);
				if(!@db_query($createSQL)){
					echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
					echo '<div class="text-danger">' . $Translation['mysql said'] . db_error(db_link()) . '</div>';
				}else{
					echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
				}
			}
		}

		echo "</div>";

		$out=ob_get_contents();
		ob_end_clean();
		if(!$silent){
			echo $out;
		}
	}
?>